'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = provideTranslate;

var _react = require('react');

var _inherits = require('inherits');

var _inherits2 = _interopRequireDefault(_inherits);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createComponent(CurrentComponent) {
  function Connector() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _react.Component.apply(this, args);
  }

  (0, _inherits2.default)(Connector, _react.Component);

  var componentName = CurrentComponent.displayName || CurrentComponent.name;
  Connector.displayName = componentName + 'T';
  Connector.contextTypes = {
    t: _react.PropTypes.func.isRequired
  };

  Connector.prototype.render = function render() {
    return (0, _react.createElement)(CurrentComponent, _extends({}, this.props, {
      t: this.context.t
    }));
  };

  (0, _hoistNonReactStatics2.default)(Connector, CurrentComponent);

  return Connector;
}

function provideTranslate() {
  for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  // support decorator pattern
  if (args.length === 0) {
    return function (ComponentToDecorate) {
      return createComponent(ComponentToDecorate);
    };
  }

  return createComponent.apply(null, args);
}